

fmod <- function(a,b) { return(a-b*floor(a/b)); }

fgr2 = function(D) {
	dis = (dist(D[, 1]))^2
	for (j in 2:dim(D)[2]) dis = dis * (dist(D[, j]))^2
	DIST = as.matrix(dis)
	fn = sum(1/dis)
	lfn = log(fn)
	return(lfn)
}
  
addfrom <- function(m,tryF,ballr2) {
	sumF <- sum(tryF) 
	if( sum(tryF^2)*(m+1)/m - sumF^2/m > ballr2 ) return(0)
	dd2m <- rep(0,2*m+2)
	dd2m[1:m] <- -2*(m+1)*tryF +2*sumF +m
	dd2m[(m+1):(2*m)] <- 2*(m+1)*tryF -2*sumF +m
	dd2m[2*m+1] <- -2*sumF +m
	dd2m[2*m+2] <- 2*sumF +m
	minv=0
	mind=0
	for(s in 1:(2*m+2)) if(dd2m[s]<minv) { minv <- dd2m[s]; mind <- s; }
	return(mind)
}


m=4
n=10*(m+1)
w1=100
w2=1
results = matrix(0,w1,5)
sim=1

set.seed(sim)

#### Get design

	n <- as.integer(n)
	if(is.na(n)) stop("n must be an integer greater than one")
	if(n<=1) stop("n must be an integer greater than one")
	m <- as.integer(m)
	if(is.na(m)) stop("m must be an integer greater than one")
	if(m<=1) stop("m must be an integer greater than one")
	w1 <- as.integer(w1)
	if(is.na(w1)) stop("w1 must be a positive integer")
	if(w1<=0) stop("w1 must be a positive integer")
	w2 <- as.integer(w2)
	if(is.na(w2)) stop("w2 must be a positive integer")
	if(w2<=0) stop("w2 must be a positive integer")

	G <- matrix(-1,m,m)
	diag(G) <- m-sqrt(m+1)
	G <- G/(sqrt(m+1)-1)/sqrt(m)
	etamin <- sqrt(m+1)/sqrt(2*m)
	detG <- (m+1)^((m-1)/2)/m^{m/2}
	rhoc <- sqrt((m+2)/12)
	Omega <- pi^(m/2)/gamma(m/2+1)
	Theta <- Omega*rhoc^m/detG
	l <- (n*detG)^(1/m)

	
	
	nsd=0
#	for(r in (m+1)/m^seq(1.7,.99,-0.05))
#	{
	r = (m+1)/m
#times=matrix(0,w1,5)
#time0=proc.time()[3]
	
#### Generate the big F. 	
	
		ballr <- l/2 * sqrt(m) + rhoc*r 
		ballr2 <- ballr^2
		N <- Omega * ballr^m / detG *1.1 + 1000*m
		
		FE <- matrix(0,N,m)
		nrowFE <- 1
		srowFE <- 1
		while(srowFE<=nrowFE ) {  
			tF <- FE[srowFE,1:m]
			maxF <- max(tF)
			minF <- min(tF)
			for(s in 1:m) if(tF[s]>=max(tF)-1) {
				tryF <- tF
				tryF[s] <- tryF[s]+1
				if(addfrom(m,tryF,ballr2)==s) { 
					nrowFE <- nrowFE +1
					FE[nrowFE,1:m] <- tryF
				}
			}
			for(s in 1:m) if(tF[s]<=min(tF)+1) {
				tryF <- tF
				tryF[s] <- tryF[s]-1
				if(addfrom(m,tryF,ballr2)==m+s) { 
					nrowFE <- nrowFE +1
					FE[nrowFE,1:m] <- tryF
				}
			}
			tryF <- tF+1
			if(addfrom(m,tryF,ballr2)==2*m+1) { 
				nrowFE <- nrowFE +1
				FE[nrowFE,1:m] <- tryF
			}
			tryF <- tF-1
			if(addfrom(m,tryF,ballr2)==2*m+2) { 
				nrowFE <- nrowFE +1
				FE[nrowFE,1:m] <- tryF
			}
			srowFE <- srowFE +1
			if(nrowFE>=dim(FE)[1]-2*m-2) FE=rbind(FE,matrix(0,N,m))
		}
		FE <- FE[1:nrowFE,]
		
#times[1,1]=proc.time()[3]-time0
#### Optimize R and delta
		
		
		minfgr2=0  
		mindn=0	
#		for(ll in 1:(w*2)) {
		ll=1
		for(ll in 1:w1){
		
#time0=proc.time()[3]
			
			CPair <- matrix(0,m*(m-1)/2,2)
			row <- 1
			for(i in 1:(m-1)) for(j in (i+1):m) { CPair[row,1] <- i; CPair[row,2] <- j; row <- row+1; }
			R <- diag(m)
			if(m>2) for(a in 1:((m*(m-1)/2))) {
				alpha <- runif(1,0,2*pi)
				thepair <- CPair[a,]
				W <- diag(m)
				W[thepair[1],thepair[1]] <- cos(alpha); W[thepair[2],thepair[2]] <- cos(alpha); 
				W[thepair[1],thepair[2]] <- sin(alpha); W[thepair[2],thepair[1]] <- -sin(alpha); 
				R <- R%*%W
			}
			GR <- G %*% R
			E <- FE %*% GR 

			slicesE <- FE[,1] 
			for(j in 2:m) slicesE <- slicesE + FE[,j]
			slicesE <- fmod(slicesE,m+1)
			
			isE <- FALSE
			isB <- FALSE
			isL <- FALSE
			epsilonV <- matrix(0,3,m)
			while(1) {
				epsilon <- runif(m,-rhoc*r,rhoc*r)
				D <- E
				slices <- slicesE
				for(j in 1:m) { if(length(D)<=m) break; indexs=abs(D[,j]-epsilon[j])<l/2; D <- D[ indexs ,]; slices <- slices[ indexs ]; }
				if(length(D)<=m) next; 
				if(dim(D)[1]==n) { isE <- TRUE; epsilonV[1,] <- epsilon; break; }
				if(isL==FALSE & dim(D)[1]<n) { isL <- TRUE; epsilonV[2,] <- epsilon; }
				if(isB==FALSE & dim(D)[1]>n) { isB <- TRUE; epsilonV[3,] <- epsilon; }
				if(isL==TRUE & isB==TRUE) break;
			}
#			try1 <- i
#			if(try1==20) next; 
#			try2 <- 0
#			try3 <- 0
			
			if(isE==FALSE) for(j in 1:(m-1)) {
#				try2 <- j
				epsilon <- c(epsilonV[2,1:j],epsilonV[3,(j+1):m])
				D <- E
				slices <- slicesE
				for(j in 1:m) { if(length(D)<=m) break; indexs=abs(D[,j]-epsilon[j])<l/2; D <- D[ indexs ,]; slices <- slices[ indexs ]; }
				if(length(D)<=m) next; 
				if(dim(D)[1]==n) { isE <- TRUE; epsilonV[1,] <- epsilon; break; }
				if(dim(D)[1]<n) { epsilonV[2,] <- epsilon; break; }
				if(dim(D)[1]>n) { epsilonV[3,] <- epsilon; }
			}

			if(isE==FALSE) while(1) { 
#				try3 <- k
				epsilon <- (epsilonV[2,]+epsilonV[3,])/2
				D <- E
				slices <- slicesE
				for(j in 1:m) { if(length(D)<=m) break; indexs=abs(D[,j]-epsilon[j])<l/2; D <- D[ indexs ,]; slices <- slices[ indexs ]; }
				if(length(D)<=m) next; 
				if(dim(D)[1]==n) { isE <- TRUE; epsilonV[1,] <- epsilon; break; }
				if(dim(D)[1]<n) { epsilonV[2,] <- epsilon; }
				if(dim(D)[1]>n) { epsilonV[3,] <- epsilon; }
			}
#			if(try3==20) next;

#			print(c(try1,try2,try3));

#times[l,2]=proc.time()[3]-time0
#time0=proc.time()[3]
			
			nsd=nsd+1
			for(j in 1:m) D[,j] <- (D[,j]-epsilon[j]) / l + .5
			nslices <- rep(0,m+1) 
			for(j in 1:(m+1)) nslices[j] <- sum(slices==j-1)
			dn <- sum((nslices-n/(m+1))^2)
			
#			print(c(epsilon,dim(D)[1],nslices,dn)); 
			
			searchwindow <- sqrt( l/n * rhoc*r )
			epsilonopt <- epsilon 
			dnopt <- dn
#			for(i in 1:w2) if(dnopt>0) {
				thedim = sample(1:m,1)
				epsiloncenter <- epsilonopt[thedim]
				if(epsiloncenter < -rhoc*r+searchwindow)  epsiloncenter <- -rhoc*r+searchwindow;
				if(epsiloncenter >  rhoc*r-searchwindow)  epsiloncenter <-  rhoc*r-searchwindow;
				epsilon <- epsilonopt 
				epsilon[thedim] = epsiloncenter + runif(1,-searchwindow,searchwindow)
				D <- E
				slices <- slicesE
				for(j in 1:m) { if(length(D)<=m) break; indexs=abs(D[,j]-epsilon[j])<l/2; D <- D[ indexs ,]; slices <- slices[ indexs ]; }
				if(dim(D)[1]==n) { 
					for(j in 1:(m+1)) nslices[j] <- sum(slices==j-1); 
					dn <- sum((nslices-n/(m+1))^2); 
#					print(c(thedim,format(epsilon[thedim]-epsilonopt[thedim],digits=2),dim(D)[1],nslices,dn),quote=FALSE); 
					if (dn<=dnopt) { epsilonopt <- epsilon; dnopt<- dn; }
				}
#				else print(c(thedim,format(epsilon[thedim]-epsilonopt[thedim],digits=2),dim(D)[1]),quote=FALSE); 
#			}
			
#times[l,3]=proc.time()[3]-time0
#time0=proc.time()[3]

			D <- E
			slices <- slicesE
			for(j in 1:m) { if(length(D)<=m) break; indexs=abs(D[,j]-epsilonopt[j])<l/2; D <- D[ indexs ,]; slices <- slices[ indexs ]; }

			for(j in 1:m) D[,j] <- (D[,j]-epsilonopt[j]) / l + .5
			fgr2D=fgr2(D)
			
			results[ll,1]=dn
			results[ll,2]=fgr2D
			
			if((nsd==1|dnopt<mindn)|(dnopt==mindn&fgr2D<minfgr2)) {
				mindn <- dnopt
				Dopt <- D
				slicesopt <- slices+1
				minfgr2 <- fgr2D
				Ropt <- R
#				epsilonopt <- epsilon
			}
#			print(c(ll,dnopt,fgr2D));
#			print(' ');

		}
		
		
	D = Dopt
	slices = slicesopt
	

	

postscript('dnpsi4.eps',horizontal=FALSE,width=6,height=6.2)
par(cex.lab=1.3,cex.lab=1.3,cex.axis=1.3,cex.main=1.3,lwd=1)
par(mar=c(3,3.5,2,0.5),mgp=c(2.2,0.5,0))
#par(las=1)
par(mfrow=c(1,1))

	plot(results[1:100,2]~results[1:100,1],xlab=expression(varphi(D)),ylab=expression(psi(D)),xlim=c(0,40),main='p=4, n=50')

dev.off()

